<template>
    <div id="menu-slide" uk-offcanvas>
        <div class="uk-offcanvas-bar">
            <button class="uk-offcanvas-close" type="button" uk-close></button>
            <ul class="uk-nav uk-nav-default">
                <li class="uk-parent">
                    <router-link :to="{ name: 'Accueil' }">
                        <a href="#" class="text-menu" @click="fermerMenu()"
                            >Accueil</a
                        >
                    </router-link>
                </li>
                <li class="uk-parent">
                    <router-link :to="{ name: 'CommentCaMarche' }">
                        <a href="#" class="text-menu" @click="fermerMenu()"
                            >Comment ça marche ?</a
                        >
                    </router-link>
                </li>
                <li class="uk-parent">
                    <router-link :to="{ name: 'OuJouer' }">
                        <a href="#" class="text-menu" @click="fermerMenu()"
                            >Où jouer ?</a
                        >
                    </router-link>
                </li>
                <li class="uk-parent">
                    <router-link :to="{ name: 'InformationsOfficielles' }">
                        <a href="#" class="text-menu" @click="fermerMenu()"
                            >Informations officielles</a
                        >
                    </router-link>
                </li>
                <li class="uk-parent">
                    <router-link :to="{ name: 'SuivreActualites' }">
                        <a href="#" class="text-menu" @click="fermerMenu()"
                            >Suivre l'actualité</a
                        >
                    </router-link>
                </li>
                <li class="uk-parent" v-if="isConnecte()">
                    <router-link :to="{ name: 'Lexique' }">
                        <a href="#" class="text-menu" @click="fermerMenu()"
                            >Lexique</a
                        >
                    </router-link>
                </li>
                <!-- Administration -->
                <li class="uk-parent" v-if="isAuthorized('ADMIN')">
                    <router-link :to="{ name: 'Administration' }">
                        <a href="#" class="text-menu" @click="fermerMenu()"
                            >Administration</a
                        >
                    </router-link>
                </li>
                <!-- Professeur -->
                <li class="uk-parent" v-if="isAuthorized('PROFESSEUR')">
                    <router-link :to="{ name: 'GestionClub' }">
                        <a href="#" class="text-menu" @click="fermerMenu()"
                            >Gestion club</a
                        >
                    </router-link>
                </li>
                <li class="uk-parent" v-if="isAuthorized('PROFESSEUR')">
                    <router-link :to="{ name: 'ListeLecons' }">
                        <a href="#" class="text-menu" @click="fermerMenu()"
                            >Leçons</a
                        >
                    </router-link>
                </li>
                <li class="uk-parent" v-if="isAuthorized('PROFESSEUR')">
                    <router-link :to="{ name: 'ListeClasse' }">
                        <a href="#" class="text-menu" @click="fermerMenu()"
                            >Classes</a
                        >
                    </router-link>
                </li>
                <li class="uk-parent" v-if="isAuthorized('PROFESSEUR')">
                    <router-link :to="{ name: 'SuiviEleve' }">
                        <a href="#" class="text-menu" @click="fermerMenu()"
                            >Suivi élève</a
                        >
                    </router-link>
                </li>

                <!-- Eleve -->
                <li class="uk-parent" v-if="isConnecte()">
                    <router-link :to="{ name: 'NouveauxProblemes' }">
                        <a href="#" class="text-menu" @click="fermerMenu()"
                            >Nouveaux problèmes</a
                        >
                    </router-link>
                </li>
                <li class="uk-parent" v-if="isConnecte()">
                    <router-link :to="{ name: 'Revision' }">
                        <a href="#" class="text-menu" @click="fermerMenu()"
                            >Révisions</a
                        >
                    </router-link>
                </li>
                <li class="uk-parent" v-if="isConnecte()">
                    <router-link :to="{ name: 'DemandeInscription' }">
                        <a href="#" class="text-menu" @click="fermerMenu()"
                            >Demande d'inscription</a
                        >
                    </router-link>
                </li>
                <!-- Connexion -->
                <li
                    v-if="!$auth.isAuthenticated"
                    @click="login"
                    class="uk-parent"
                >
                    <a href="#">Connexion</a>
                </li>
                <li
                    v-if="$auth.isAuthenticated"
                    class="uk-parent"
                >
                    <a href="#" class="text-menu" @click="logout"
                        >Se déconnecter</a
                    >
                </li>
            </ul>
        </div>
    </div>
</template>

<script>
import UIkit from 'uikit';
export default {
    name: 'Nav',
    methods: {
        async login() {
            const element = await document.getElementById('auth-modal');
            UIkit.modal(element).show();
        },
        logout() {
            this.$auth.logout();
        },
        isConnecte() {
            return this.$auth.isConnecte();
        },
        isAuthorized(roleDemande) {
            return (
                this.$auth.isConnecte() &&
                this.$auth.isRoleAutorise(roleDemande)
            );
        },
        fermerMenu() {
            let offcanvas = document.getElementById('menu-slide');
            UIkit.offcanvas(offcanvas).hide();
        }
    }
};
</script>

<style scoped>
.text-menu {
    color: #999;
}
.text-menu:hover {
    color: rgba(255, 255, 255, 0.7);
    text-decoration: none;
}
</style>
